;**********************************************************************
;    Filename:	youbi.asm 
;    Date:          	2006/1/8
;    File Version:
;**********************************************************************

	list      		p=16F88			 ; list directive to define processor
	#include		 <p16F88.inc>		 ; processor specific variable definitions

	__CONFIG   _CONFIG1,  _CP_OFF & _WDT_OFF & _PWRTE_ON & _INTRC_IO & _LVP_OFF & _MCLR_OFF 

;***** VARIABLE DEFINITIONS
w_temp			EQU     0x20			 ; variable used for context saving 
status_temp		EQU     0x21			 ; variable used for context saving

wait_data		EQU	0x30		;wait data ram
taihi			EQU	0x31		;taihi data
youbi			EQU	0x32		;nengou 

sagyou			EQU	0x38		;sagyou
wait_data_2		EQU	0x39		;wait data 2
key_data			EQU	0x3a		;key data ram
									;key_data,2  RA6 (manyu up)
									;key_data,4  RB7 (youbi up)

key_input		EQU	0x3b		;key input ram
									;key_input,2  RA6 (manyu up)
									;key_input,4  RB7 (youbi up)
key_cnt0		EQU	0x3c		;key_input2 repeat count

sagyou2			EQU	0x3e		;sagyou2

hyouji1			EQU	0x40		;hyouji1
hyouji2			EQU	0x41		;hyouji2
hyouji3			EQU	0x42		;hyouji3
hyouji4			EQU	0x43		;hyouji4
hyouji5			EQU	0x44		;hyouji5
hyouji6			EQU	0x45		;hyouji6
hyouji7			EQU	0x46		;hyouji7
hyouji8			EQU	0x47		;hyouji8
hyouji9			EQU	0x48		;hyouji9
hyoujia			EQU	0x49		;hyoujia


tm0_setdata		EQU	0x63		;FFH-63H=156 156*128=19.968msec

;**********************************************************************
		ORG     		0x000             ; processor reset vector
  		goto    		main              ; go to beginning of program

;----------------------------------------------------------------------------------
		ORG     		0x004             ; interrupt vector location
		movwf   	w_temp            ; save off current W register contents
		movf		STATUS,w          ; move status register into W register
		movwf		status_temp       ; save off contents of STATUS register

		;---------------------------------	
		bcf			INTCON,TMR0IF
		movlw		tm0_setdata
		movwf		TMR0


next_int
		movf    		status_temp,w     ; retrieve copy of STATUS register
		movwf		STATUS            ; restore pre-isr STATUS register contents
		swapf   		w_temp,f
		swapf  		 w_temp,w          ; restore pre-isr W register contents
		retfie                    ; return from interrupt
;---------------------------------------------------------------------------------------
main
		call			osc_set
		call			port_set
		call			ad_set
		
		movlw		0ffh
		movwf		PORTA
		movlw		0ffh
		movwf		PORTB

		call			timer0_set

		movlw		00h
		movwf		youbi
		
;--------------------------------------
main_loop
		movlw		0ffh				;key input clear
		movwf		key_input
		btfss		PORTA,6		;RA6 check
		bcf			key_input,2		;RA6 input ari
		btfss		PORTB,7		;RB7 check
		bcf			key_input,4		;RB7 input ari	
		;--------------------------------- LED disp data
		movf		youbi,0
		sublw		00h
		btfsc		STATUS,2
		goto		led_disp_0
		movf		youbi,0
		sublw		01h
		btfsc		STATUS,2
		goto		led_disp_1
		movf		youbi,0
		sublw		02h
		btfsc		STATUS,2
		goto		led_disp_2
		movf		youbi,0
		sublw		03h
		btfsc		STATUS,2
		goto		led_disp_3
		movf		youbi,0
		sublw		04h
		btfsc		STATUS,2
		goto		led_disp_4
		movf		youbi,0
		sublw		05h
		btfsc		STATUS,2
		goto		led_disp_5
		movf		youbi,0
		sublw		06h
		btfsc		STATUS,2
		goto		led_disp_6
		goto		led_disp_next		
led_disp_0
		movlw		36h
		movwf		hyouji1
		movlw		50h
		movwf		hyouji2
		movlw		56h
		movwf		hyouji3
		movlw		56h
		movwf		hyouji4
		movlw		36h
		movwf		hyouji5
		movlw		36h
		movwf		hyouji6
		movlw		25h
		movwf		hyouji7
		movlw		05h
		movwf		hyouji8
		movlw		15h
		movwf		hyouji9
		movlw		36h
		movwf		hyoujia
		goto		led_disp_next
led_disp_1
		movlw		50h
		movwf		hyouji1
		movlw		5dh
		movwf		hyouji2
		movlw		5dh
		movwf		hyouji3
		movlw		5dh
		movwf		hyouji4
		movlw		3dh
		movwf		hyouji5
		movlw		05h
		movwf		hyouji6
		movlw		75h
		movwf		hyouji7
		movlw		45h
		movwf		hyouji8
		movlw		75h
		movwf		hyouji9
		movlw		06h
		movwf		hyoujia
		goto		led_disp_next
led_disp_2
		movlw		16h
		movwf		hyouji1
		movlw		56h
		movwf		hyouji2
		movlw		16h
		movwf		hyouji3
		movlw		50h
		movwf		hyouji4
		movlw		16h
		movwf		hyouji5
		movlw		44h
		movwf		hyouji6
		movlw		37h
		movwf		hyouji7
		movlw		36h
		movwf		hyouji8
		movlw		37h
		movwf		hyouji9
		movlw		44h
		movwf		hyoujia
		goto		led_disp_next
led_disp_3
		movlw		50h
		movwf		hyouji1
		movlw		5dh
		movwf		hyouji2
		movlw		1dh
		movwf		hyouji3
		movlw		5dh
		movwf		hyouji4
		movlw		5dh
		movwf		hyouji5
		movlw		35h
		movwf		hyouji6
		movlw		35h
		movwf		hyouji7
		movlw		34h
		movwf		hyouji8
		movlw		35h
		movwf		hyouji9
		movlw		4dh
		movwf		hyoujia
		goto		led_disp_next
led_disp_4
		movlw		10h
		movwf		hyouji1
		movlw		5eh
		movwf		hyouji2
		movlw		18h
		movwf		hyouji3
		movlw		5eh
		movwf		hyouji4
		movlw		5eh
		movwf		hyouji5
		movlw		0eh
		movwf		hyouji6
		movlw		5dh
		movwf		hyouji7
		movlw		5ch
		movwf		hyouji8
		movlw		5eh
		movwf		hyouji9
		movlw		0dh
		movwf		hyoujia
		goto		led_disp_next
led_disp_5
		movlw		31h
		movwf		hyouji1
		movlw		5eh
		movwf		hyouji2
		movlw		10h
		movwf		hyouji3
		movlw		57h
		movwf		hyouji4
		movlw		58h
		movwf		hyouji5
		movlw		06h
		movwf		hyouji6
		movlw		5dh
		movwf		hyouji7
		movlw		5ch
		movwf		hyouji8
		movlw		5dh
		movwf		hyouji9
		movlw		5dh
		movwf		hyoujia
		goto		led_disp_next
led_disp_6
		movlw		51h
		movwf		hyouji1
		movlw		5eh
		movwf		hyouji2
		movlw		50h
		movwf		hyouji3
		movlw		57h
		movwf		hyouji4
		movlw		38h
		movwf		hyouji5
		movlw		35h
		movwf		hyouji6
		movlw		25h
		movwf		hyouji7
		movlw		05h
		movwf		hyouji8
		movlw		15h
		movwf		hyouji9
		movlw		36h
		movwf		hyoujia
		goto		led_disp_next
led_disp_next
		;--------------------------------- hyouji
disp_hyouji
		call			clear_sel
		movf		hyouji1,0
		movwf		PORTB
		movlw		00h
		iorlw		0f0h
		movwf		PORTA
		call			wait_11
		call			clear_sel
		movf		hyouji2,0
		movwf		PORTB
		movlw		01h
		iorlw		0f0h
		movwf		PORTA
		call			wait_11		
		call			clear_sel
		movf		hyouji3,0
		movwf		PORTB
		movlw		02h
		iorlw		0f0h
		movwf		PORTA
		call			wait_11
		call			clear_sel
		movf		hyouji4,0
		movwf		PORTB
		movlw		03h
		iorlw		0f0h
		movwf		PORTA
		call			wait_11
		call			clear_sel
		movf		hyouji5,0
		movwf		PORTB
		movlw		04h
		iorlw		0f0h
		movwf		PORTA
		call			wait_11
		call			clear_sel
		movf		hyouji6,0
		movwf		PORTB
		movlw		05h
		iorlw		0f0h
		movwf		PORTA
		call			wait_11
		call			clear_sel
		movf		hyouji7,0
		movwf		PORTB
		movlw		06h
		iorlw		0f0h
		movwf		PORTA
		call			wait_11
		call			clear_sel
		movf		hyouji8,0
		movwf		PORTB
		movlw		07h
		iorlw		0f0h
		movwf		PORTA
		call			wait_11
		call			clear_sel
		movf		hyouji9,0
		movwf		PORTB
		movlw		08h
		iorlw		0f0h
		movwf		PORTA
		call			wait_11
		call			clear_sel
		movf		hyoujia,0
		movwf		PORTB
		movlw		09h
		iorlw		0f0h
		movwf		PORTA
		call			wait_11
		call			clear_sel
disp_end
		;----------------------------------RA6 sw check
		btfss		PORTA,6		;RA6 sw key check
		goto		sw1_next
		bsf			key_data,2		;RA6 sw key off
		goto		sw1_end
sw1_next
		btfsc		key_input,2		;RA6 sw input check
		goto		sw1_end
		;------------------------
		btfsc		PORTA,5
		goto		sw1_end
		;------------------------ 
		btfss		key_data,2		;RA6 sw on check
		goto		sw1_rep
		bcf			key_data,2		;RA6 sw on
		;------------------------
		call			key_cnt_set
sw1_next_r
		;------------------------
		call			youbi_up
		goto		sw_end
		;------------------------
sw1_rep
		decfsz		key_cnt0,1
		goto		sw1_end
		call			key_cnt_set_r
		goto		sw1_next_r

sw1_end
		;------------------------
		;----------------------------------RB7 input check
		btfss		PORTB,7		;RB7 input check
		goto		sw3_next
		bsf			key_data,4		;RB7 input nashi
		goto		sw3_end
sw3_next
		btfsc		key_input,4		;RB7 input check
		goto		sw3_end
		;------------------------
		btfss		PORTA,5
		goto		sw3_end
		;------------------------ 
		btfss		key_data,4		;RB7 input check
		goto		sw3_end
		bcf			key_data,4		;RB7 input ari		
		;------------------------		
		call			youbi_up
sw3_end
		;------------------------


sw_end
	
;---------------------------------------
		goto		main_loop
;---------------------------------------
youbi_up
		incf		youbi,1
		movf		youbi,0
		sublw		07h
		btfss		STATUS,2
		return
		movlw		00h
		movwf		youbi
		return
;-------------------------------------------------------------------------------
wait_20
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		return
;-------------------------------------------------------------------------------
wait_11
		movlw		01h
		movwf		wait_data_2
wait_10_2
		call			wait_1
		decfsz		wait_data_2,1
		goto		wait_10_2
		return

wait_0
		movlw		0ffh
		movwf		wait_data
		goto		wait_2
wait_1		
		movlw		0ffh
		movwf		wait_data
wait_2
		nop
		decfsz		wait_data,1
		goto		wait_2
		return
;------------------------------------------------------------------------------
clear_sel
		movlw		0ffh
		movwf		PORTA
		return
;------------------------------------------------------------------------------
key_cnt_set_r
		movlw		015h
		goto		key_cnt_set2
key_cnt_set
		movlw		030h
key_cnt_set2
		movwf		key_cnt0
		return
;------------------------------------------------------------------------------
banksel_0
		bcf			STATUS,RP0
		nop
		bcf			STATUS,RP1
		nop
		return
banksel_1
		bsf			STATUS,RP0
		nop
		bcf			STATUS,RP1
		nop
		return
banksel_2
		bcf			STATUS,RP0
		nop
		bsf			STATUS,RP1
		nop
		return
banksel_3
		bsf			STATUS,RP0
		nop
		bsf			STATUS,RP1
		nop
		return
;------------------------------------------------------------------------------
osc_set
		call			banksel_1
								;(0)NC
								;(110)IRCF2-IRCF0
								;(0)OSTS
								;(1)IOFS
								;(00)SCS
		movlw		64h
		movwf		OSCCON
		call			banksel_0
		return
;-------------------------------------------------------------------------------
port_set							;RA0,RA1,RA2,RA3,RA4(OUT)
								;RA5,RA6(IN)
								;RB0,RB1,RB2,RB3,RB4,RB5,RB6(OUT)
								;RB7(IN)
		call			banksel_1
		clrf			TRISA
		bsf			TRISA,5
		nop
		bsf			TRISA,6
		nop
		clrf			TRISB
		bsf			TRISB,7
		nop
		call			banksel_0
		return
;------------------------------------------------------------------------------
ad_set
								;(01)ADCS1,ADCS0
								;(000)CHS2,CHS1,CHS0
								;(0)GO/DONE
								;(0)NC
								;(0)ADON
		movlw		40h
		movwf		ADCON0
		call			banksel_1
								;(0)ADFM
								;(1)ADCS2
								;(00)VCFG1,VCFG0
								;(0000)
		movlw		40h
		movwf		ADCON1
								;(0)NC
								;(0000000)ANS6-ANS0
		movlw		00h
		movwf		ANSEL
		call			banksel_0
		return
;------------------------------------------------------------------------------
timer0_set

		call			banksel_1
		movlw		086h		;(1)PORTB NOT PULLUP
								;(0)INTEDG
								;(0)TOCS
								;(0)TOSE
								;(0)PSA
								;(110)1/128
		movwf		OPTION_REG
		call			banksel_0

		movlw		tm0_setdata
		movwf		TMR0
		bcf			INTCON,TMR0IE
		bcf			INTCON,GIE
		return
;-------------------------------------------------------------------------------

		end                     ; directive 'end of program'
